program StarRemover; 	{Program upravuje TAP soubory tak, ze nahradi v
			{BASICOvskych castech LOAD hvezdicku mezerou.}
                        {NEUMI upravovat TAP soubory obsahujici bezhlavickove
                         soubory!}

                        {verze 1.0 02.09.2002 19:22 X-agon of Phantasy}
                        {TODO: - cekat na bugreporty :-)}

uses crt, dos;


const
	MAX_FILESIZE	 	= 65520;
        LOAD: byte		= $EF;	{ASCII hodnota LOAD}
        STAR: byte		= $2A;	{ASCII hodnota '*'}
        MEZERA: word    	= $20;  {ASCII hodnota ' '}


type	zsoubor = array[1..MAX_FILESIZE] of byte;


var
	ascii_tabulka: array[1..256] of string[10];
        hlavicka: array[1..21] of byte; {17hlavicka+1crc+1flag+2len}

        Psoubor: ^zsoubor;
        mod_zmen: string;
	checksum, flag: byte;
        iter, uvod_delka: word;
        vstupni_soubor, vystupni_soubor: file;
        nazev_vstupniho_souboru, nazev_vystupniho_souboru: string;

        D: DirStr;
        N: NameStr;
        E: ExtStr;

        P: Pointer;


procedure LoadAsciiTable;
{Ulozi do 'ascii_tabulka' retezce odpovidajici prikazum BASICu}
var
	iter: byte;

begin
	for iter:= 1 to 32 do ascii_tabulka[iter] := '?';      {ridici znaky}
        for iter:= 33 to 128 do ascii_tabulka[iter] := chr(iter-1); {beze zmen}
        for iter:= 129 to 144 do ascii_tabulka[iter] := chr(220); {cerny ctverec}
        for iter:= 145 to 165 do ascii_tabulka[iter] := 'UDG-'+chr(iter-80);
	ascii_tabulka[166] := 'RND';
	ascii_tabulka[167] := 'INKEY$';
	ascii_tabulka[168] := 'PI';
	ascii_tabulka[169] := 'FN';
	ascii_tabulka[170] := 'POINT';
	ascii_tabulka[171] := 'SCREEN$';
	ascii_tabulka[172] := 'ATTR';
	ascii_tabulka[173] := 'AT';
	ascii_tabulka[174] := 'TAB';
	ascii_tabulka[175] := 'VAL$';
	ascii_tabulka[176] := 'CODE';
	ascii_tabulka[177] := 'VAL';
	ascii_tabulka[178] := 'LEN';
	ascii_tabulka[179] := 'SIN';
	ascii_tabulka[180] := 'COS';
	ascii_tabulka[181] := 'TAN';
	ascii_tabulka[182] := 'ASN';
	ascii_tabulka[183] := 'ACS';
	ascii_tabulka[184] := 'ATN';
	ascii_tabulka[185] := 'LN';
	ascii_tabulka[186] := 'EXP';
	ascii_tabulka[187] := 'INT';
	ascii_tabulka[188] := 'SQR';
	ascii_tabulka[189] := 'SGN';
	ascii_tabulka[190] := 'ABS';
	ascii_tabulka[191] := 'PEEK';
	ascii_tabulka[192] := 'IN';
	ascii_tabulka[193] := 'USR';
	ascii_tabulka[194] := 'STR$';
	ascii_tabulka[195] := 'CHR$';
	ascii_tabulka[196] := 'NOT';
	ascii_tabulka[197] := 'BIN';
	ascii_tabulka[198] := 'OR';
	ascii_tabulka[199] := 'AND';
	ascii_tabulka[200] := '<=';
	ascii_tabulka[201] := '>=';
	ascii_tabulka[202] := '<>';
	ascii_tabulka[203] := 'LINE';
	ascii_tabulka[204] := 'THEN';
	ascii_tabulka[205] := 'TO';
	ascii_tabulka[206] := 'STEP';
	ascii_tabulka[207] := 'DEF FN';
	ascii_tabulka[208] := 'CAT';
	ascii_tabulka[209] := 'FORMAT';
	ascii_tabulka[210] := 'MOVE';
	ascii_tabulka[211] := 'ERASE';
	ascii_tabulka[212] := 'OPEN #';
	ascii_tabulka[213] := 'CLOSE #';
	ascii_tabulka[214] := 'MERGE';
	ascii_tabulka[215] := 'VERIFY';
	ascii_tabulka[216] := 'BEEP';
	ascii_tabulka[217] := 'CIRCLE';
	ascii_tabulka[218] := 'INK';
	ascii_tabulka[219] := 'PAPER';
	ascii_tabulka[220] := 'FLASH';
	ascii_tabulka[221] := 'BRIGHT';
	ascii_tabulka[222] := 'INVERSE';
	ascii_tabulka[223] := 'OVER';
	ascii_tabulka[224] := 'OUT';
	ascii_tabulka[225] := 'LPRINT';
	ascii_tabulka[226] := 'LLIST';
	ascii_tabulka[227] := 'STOP';
	ascii_tabulka[228] := 'READ';
	ascii_tabulka[229] := 'DATA';
	ascii_tabulka[230] := 'RESTORE';
	ascii_tabulka[231] := 'NEW';
	ascii_tabulka[232] := 'BORDER';
	ascii_tabulka[233] := 'CONTINUE';
	ascii_tabulka[234] := 'DIM';
	ascii_tabulka[235] := 'REM';
	ascii_tabulka[236] := 'FOR';
	ascii_tabulka[237] := 'GO TO';
	ascii_tabulka[238] := 'GO SUB';
	ascii_tabulka[239] := 'INPUT';
	ascii_tabulka[240] := 'LOAD';
	ascii_tabulka[241] := 'LIST';
	ascii_tabulka[242] := 'LET';
	ascii_tabulka[243] := 'PAUSE';
	ascii_tabulka[244] := 'NEXT';
	ascii_tabulka[245] := 'POKE';
	ascii_tabulka[246] := 'PRINT';
	ascii_tabulka[247] := 'PLOT';
	ascii_tabulka[248] := 'RUN';
	ascii_tabulka[249] := 'SAVE';
	ascii_tabulka[250] := 'RANDOMIZE';
	ascii_tabulka[251] := 'IF';
	ascii_tabulka[252] := 'CLS';
	ascii_tabulka[253] := 'DRAW';
	ascii_tabulka[254] := 'CLEAR';
	ascii_tabulka[255] := 'RETURN';
	ascii_tabulka[256] := 'COPY';

end;

procedure TestInputFile;
var
	hodnota: byte;

begin
        seek(vstupni_soubor, 3);
        blockread(vstupni_soubor, hodnota, 1);

	if (hodnota > 3) or (FileSize(vstupni_soubor) < 4) then
	begin	{pouze 0,1,2,3} {nejkratsi TAP ma 4 bytes - 02 00 FF FF}

        	writeln(nazev_vstupniho_souboru, ' is not a valid TAP file!');

                close(vstupni_soubor);
                close(Output);
                halt;
        end;


end;

procedure PrepareOutputFile;
{Priprav vystupni soubor}
begin

        assign(vystupni_soubor, nazev_vystupniho_souboru);
        {$I-}
        rewrite(vystupni_soubor, 1);
        {$I+}
        	if (IOResult <> 0) then
                begin
                	writeln('Cannot open "', nazev_vystupniho_souboru, '" for writing!');

                        close(vstupni_soubor);
                        close(Output);
                        halt;
                end;
end;


procedure ViewBASICFile(zacatek: word; delka: word);
{Zjedodusene zobrazi BASIC soubor}
{zacatek = index v souboru (v bytech)}
{delka   = kolik bytu intepretovat jako BASIC}

var
	iter, hodnota: word;
        i: byte;
begin

       	for iter:=zacatek to zacatek+delka do
        begin
        	hodnota:= Psoubor^[iter] + 1;

                	if (hodnota > 165) then {Zacinaji BASIC prikazy}
                       	write(' ',ascii_tabulka[hodnota],' ')
			else
			begin
                            if (hodnota = 14) then writeln
                            else write(ascii_tabulka[hodnota]);
                        end;
        end;

        writeln;
end;

function AlterBASICFile(delka: word):byte;
{Upravime BASIC program, odstranime '*' a vratime pocet nahrazeni}
{(kvuli checksumu)}
var
	iter:  word;
        byte1, byte2, pocet_zmen, i, zbytek: byte;
        klavesa: char;

begin
        iter:= 1; pocet_zmen:= 0;
        while(iter < delka) do {soubor[delka-1] by musel byt LOAD}
        begin
                byte1:= Psoubor^[iter];
                byte2:= Psoubor^[iter+1];

                if (byte1 = LOAD) and (byte2 = STAR) then
                begin
                	inc(pocet_zmen);

                        byte2:= MEZERA;

                        if (mod_zmen = 'A') then Psoubor^[iter+1]:= byte2
                        else {Provadime manualni potvrzovani zmen}
                        begin

                        	zbytek:= 2; {Neni misto, konec souboru, treba}
                        	if ( (delka-iter) > 14 ) then zbytek:= 15;
                        	ViewBasicFile(iter, zbytek);
                                write('Replace ? [Y/N]');
                        	klavesa:= ReadKey;
                                writeln(klavesa);

                        	if (klavesa = 'y') or (klavesa = 'Y')
				then Psoubor^[iter+1]:= byte2
                        	else
				begin
			   		Psoubor^[iter+1]:= STAR;
                                	dec(pocet_zmen);
				end;
                        end;
                end;

        	inc(iter);
        end;


        AlterBASICFile:= pocet_zmen;
end;



procedure AlterTAPFile;
{Najde v BASICovych programech sekvenci 'LOAD *' a nahradi '*'
 mezerou}

var
	iter, flag, typ, checksum, kolik_zmen: byte;
        uvod_delka, delka, index: word;
        znak: char;


begin

	{Budeme ukladat soubor}
	new(Psoubor);

        {Otestujeme jednoduchym testem, jestli jde o TAP soubor}
        {Testujeme na spravny typ souboru (0,1,2,3) v hlavicce}
        {Test selze, pokud prvnim souborem v TAPce neni soubor s
	{s hlavickou!}
	TestInputFile;

        {Priprav vystupni soubor pro zapis}
	PrepareOutputFile;

	{Napln ascii tabulku}
	LoadAsciiTable;


        seek(vstupni_soubor, 0);

        while( FilePos(vstupni_soubor) <> FileSize(vstupni_soubor) ) do
        begin
		blockread(vstupni_soubor, hlavicka, sizeof(hlavicka));

                delka:= hlavicka[15] + 256*hlavicka[16];
		{delka souboru urceneho hlavickou}

                if (hlavicka[4] <> 0) then  {BASIC = 0}
                begin
                	{Ulozime nactenou hlavicku, tu nemenime}
                	blockwrite(vystupni_soubor, hlavicka, sizeof(hlavicka));

                        {Nasleduje telo, zaciname delkou}
                        blockread(vstupni_soubor, uvod_delka, sizeof(uvod_delka));
                        blockwrite(vystupni_soubor, uvod_delka, sizeof(uvod_delka));

                        {Pote flag}
                        blockread(vstupni_soubor, flag, sizeof(flag));
                        blockwrite(vystupni_soubor, flag, sizeof(flag));

                        {Pak samotna data}
                        blockread(vstupni_soubor, Psoubor^, delka);
                        blockwrite(vystupni_soubor, Psoubor^, delka);

                        {A uzavirame checksumem}
                        blockread(vstupni_soubor, checksum, sizeof(checksum));
                        blockwrite(vystupni_soubor, checksum, sizeof(checksum));

               end
               else
               begin
               		{Ulozime nactenou hlavicku, tu nemenime}
                	blockwrite(vystupni_soubor, hlavicka, sizeof(hlavicka));

                        {Mame BASIC telo, zaciname delkou}
                        blockread(vstupni_soubor, uvod_delka, sizeof(uvod_delka));
                        blockwrite(vystupni_soubor, uvod_delka, sizeof(uvod_delka));

                        {Pote flag}
                        blockread(vstupni_soubor, flag, sizeof(flag));
                        blockwrite(vystupni_soubor, flag, sizeof(flag));

                        {Pak samotna data}
                        blockread(vstupni_soubor, Psoubor^, delka);

                        {Zmen BASIC program, zjisti pocet nahrazeni}
                        kolik_zmen:= AlterBASICFile(delka);

                        {Uloz jej zpet do TAPu, dej pozor na zmenene CRC}
                        blockwrite(vystupni_soubor, Psoubor^, delka);

                        {A uzavirame checksumem}
                        blockread(vstupni_soubor, checksum, sizeof(checksum));

                        checksum:= $FF; {Provadeli jsme zameny, nutno prepocist CRC}
                        for index:= 1 to delka do checksum:= checksum xor Psoubor^[index];

                        blockwrite(vystupni_soubor, checksum, sizeof(checksum));
               end;

        end;

        dispose(Psoubor);
end;



{**************************************}
{    HLAVNI PROGRAM }
{**************************************}

begin

        assign(Output, '');		{Chceme presmerovavat std. vystup}
        rewrite(Output);


        fsplit(ParamStr(0), D, N, E);	{Ziskame DirName, Name, Extension}

        if (ParamCount <> 3) then
        begin
        	writeln('ZX Spectrum Star remover - TAP handling utility');
                writeln;
                write('Removes "*" after LOAD commands from Basic programs');
	        writeln(' (D80 loading syntax)');
                writeln;
                writeln('Usage: ',N,' "inputfile.tap" "outputfile.tap" "mode"');
                writeln('       "mode" is either "A"(utomatic) or "M"(anual) and');
                writeln('       determines whether to confirm changes while altering.');
                writeln;
                writeln('Note: - max. length of the file is 65520 Bytes');
                writeln('      - TAP files with headerless files not supported!');
                writeln;
                writeln('Send bugreports and comments to xhotarek@fi.muni.cz');
                writeln('Homepage: http://www.fi.muni.cz/~xhotarek');
                writeln;
                writeln('(c) 2002-09-02 X-agon of Phantasy');

                close(Output);
                halt;
        end;

        mod_zmen:= ParamStr(3);

        if (mod_zmen <> 'A') and (mod_zmen <> 'M') then
        begin
        	writeln('Invalid mode! Use "A" or "M"');

                close(Output);
                halt;
        end;

        nazev_vstupniho_souboru:=  ParamStr(1);
        nazev_vystupniho_souboru:= ParamStr(2);

        assign(vstupni_soubor, nazev_vstupniho_souboru);
        {$I-}
        reset(vstupni_soubor, 1);
        {$I+}

                if (IOResult <> 0) then
                begin
                	writeln('Cannot open "',nazev_vstupniho_souboru, '"!');

                        close(Output);
                        halt;
                end;

        {Proved to vsechno}
	AlterTAPFile;

        close(vystupni_soubor);
        close(vstupni_soubor);
	close(Output);

end.